<!-- HTML header for doxygen 1.8.18-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=9" />
    <meta name="generator" content="Doxygen 1.9.1" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>VizBlocks: src/Potentiometer.h Source File</title>
    <link href="tabs.css" rel="stylesheet" type="text/css" />
    <script type="text/javascript" src="jquery.js"></script>
    <script type="text/javascript" src="dynsections.js"></script>
     <link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
    <link href="my_customdoxygen.css" rel="stylesheet" type="text/css" />
  </head>
  <body>
    <div id="top">
      <!-- do not remove this div, it is closed by doxygen! -->
      <header id="header" class="desktop">
        <div>
          <div class="inner-header">
            <div class="logotype">
              <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" aria-hidden="true" title="Site home"
                >VizBlocks</a
              >
            </div>
            <div class="navigation">
              <button
                onclick="toggleBurger()"
                type="button"
                aria-label="toggle burger menu"
              >
                <i class="fa fa-bars"></i>
              </button>
              <nav id="menu" class="collapse">
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" class="home">Home</a>
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/about" class="about">About</a>
                <a
                  href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials/0_getting_started.html"
                  class="start"
                  >Get Started</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials" class="tutorials"
                  >Tutorials</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/docs/html" class="docs"
                  >Technical Info</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/contact" class="content">Contact</a>
              </nav>
            </div>
          </div>
        </div>
        <script>
          const toggleBurger = () => {
            const menu = document.getElementById("menu");
            if (menu.className === "collapse") {
              menu.className = "extend";
            } else {
              menu.className = "collapse";
            }
          };
          const touchDevice = "ontouchstart" in document.documentElement;
          if (touchDevice) {
            const header = document.getElementById("header");
            header.className = "mobile";
          }
        </script>
      </header>
      <!-- end header part -->
    </div>
  </body>
</html>
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Potentiometer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_potentiometer_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef POTENTIOMETER_h</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define POTENTIOMETER_h</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;Arduino.h&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="class_potentiometer.html">   23</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_potentiometer.html">Potentiometer</a></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;{</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keywordtype">int</span> EMA_S = 0;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keywordtype">float</span> EMA_a = 0.6;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keywordtype">int</span> _pin;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keywordtype">int</span> _id;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keywordtype">int</span> _value;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keywordtype">int</span> _previousReading;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160; </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordtype">bool</span> _inputFlag = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordtype">bool</span> _changeFlag = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> _previousTimer;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keywordtype">int</span> _interval = 200;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    void (*_cb)(<a class="code" href="class_potentiometer.html">Potentiometer</a>*, uint8_t, uint8_t);</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keywordtype">int</span> _read();</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160; </div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keywordtype">void</span> _setValue(<span class="keywordtype">int</span> x);</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160; </div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160; </div>
<div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="class_potentiometer.html#a4898ad98a6a277551036a8b9558533df">   58</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint8_t <a class="code" href="class_potentiometer.html#a4898ad98a6a277551036a8b9558533df">kEventStableUpdate</a> = 0;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160; </div>
<div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="class_potentiometer.html#a06d7c4ac6942d9fad402d136f2bfa6ed">   63</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint8_t <a class="code" href="class_potentiometer.html#a06d7c4ac6942d9fad402d136f2bfa6ed">kEventUnstableUpdate</a> = 1;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160; </div>
<div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="class_potentiometer.html#af2f25ccdc72808fc5e4baeeb60fe9410">   69</a></span>&#160;    <a class="code" href="class_potentiometer.html#af2f25ccdc72808fc5e4baeeb60fe9410">Potentiometer</a>(<span class="keywordtype">int</span> pin, <span class="keywordtype">int</span> <span class="keywordtype">id</span> = 99);</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160; </div>
<div class="line"><a name="l00075"></a><span class="lineno"><a class="line" href="class_potentiometer.html#a17b7977261eebcac2d6d5dbcd7adf167">   75</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_potentiometer.html#a17b7977261eebcac2d6d5dbcd7adf167">setEventHandler</a>(<span class="keywordtype">void</span> (*<span class="keyword">function</span>)(<a class="code" href="class_potentiometer.html">Potentiometer</a>*, uint8_t, uint8_t));</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160; </div>
<div class="line"><a name="l00080"></a><span class="lineno"><a class="line" href="class_potentiometer.html#a0ee40840fe135d6f1799fecdbb4d9f70">   80</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="class_potentiometer.html#a0ee40840fe135d6f1799fecdbb4d9f70">getValue</a>();</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160; </div>
<div class="line"><a name="l00085"></a><span class="lineno"><a class="line" href="class_potentiometer.html#a70a53b8e012420e689a38d1751b4269e">   85</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="class_potentiometer.html#a70a53b8e012420e689a38d1751b4269e">getId</a>();</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160; </div>
<div class="line"><a name="l00091"></a><span class="lineno"><a class="line" href="class_potentiometer.html#a6a9caf03bab70816829c574ee7e88a6b">   91</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_potentiometer.html#a6a9caf03bab70816829c574ee7e88a6b">check</a>();</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;};</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160; </div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="ttc" id="aclass_potentiometer_html"><div class="ttname"><a href="class_potentiometer.html">Potentiometer</a></div><div class="ttdoc">Psuedo-event-driven potentiometer class. Events are split into stable and unstable updates to prevent...</div><div class="ttdef"><b>Definition:</b> Potentiometer.h:24</div></div>
<div class="ttc" id="aclass_potentiometer_html_a06d7c4ac6942d9fad402d136f2bfa6ed"><div class="ttname"><a href="class_potentiometer.html#a06d7c4ac6942d9fad402d136f2bfa6ed">Potentiometer::kEventUnstableUpdate</a></div><div class="ttdeci">static const uint8_t kEventUnstableUpdate</div><div class="ttdoc">Event ID for a stable update (potentiometer has been changed, but not stopped moving yet).</div><div class="ttdef"><b>Definition:</b> Potentiometer.h:63</div></div>
<div class="ttc" id="aclass_potentiometer_html_a0ee40840fe135d6f1799fecdbb4d9f70"><div class="ttname"><a href="class_potentiometer.html#a0ee40840fe135d6f1799fecdbb4d9f70">Potentiometer::getValue</a></div><div class="ttdeci">int getValue()</div><div class="ttdoc">Returns the current stable potentiometer value.</div></div>
<div class="ttc" id="aclass_potentiometer_html_a17b7977261eebcac2d6d5dbcd7adf167"><div class="ttname"><a href="class_potentiometer.html#a17b7977261eebcac2d6d5dbcd7adf167">Potentiometer::setEventHandler</a></div><div class="ttdeci">void setEventHandler(void(*function)(Potentiometer *, uint8_t, uint8_t))</div><div class="ttdoc">Set the function that is called any time a button event is detected. Some example callback functions ...</div></div>
<div class="ttc" id="aclass_potentiometer_html_a4898ad98a6a277551036a8b9558533df"><div class="ttname"><a href="class_potentiometer.html#a4898ad98a6a277551036a8b9558533df">Potentiometer::kEventStableUpdate</a></div><div class="ttdeci">static const uint8_t kEventStableUpdate</div><div class="ttdoc">Event ID for a stable update (potentiometer has been changed, then been stable longer than _interval)...</div><div class="ttdef"><b>Definition:</b> Potentiometer.h:58</div></div>
<div class="ttc" id="aclass_potentiometer_html_a6a9caf03bab70816829c574ee7e88a6b"><div class="ttname"><a href="class_potentiometer.html#a6a9caf03bab70816829c574ee7e88a6b">Potentiometer::check</a></div><div class="ttdeci">void check()</div><div class="ttdoc">Polls the potentiometer's value and detects events. This should be called in the sketch's loop() func...</div></div>
<div class="ttc" id="aclass_potentiometer_html_a70a53b8e012420e689a38d1751b4269e"><div class="ttname"><a href="class_potentiometer.html#a70a53b8e012420e689a38d1751b4269e">Potentiometer::getId</a></div><div class="ttdeci">int getId()</div><div class="ttdoc">Returns the potentiometer ID.</div></div>
<div class="ttc" id="aclass_potentiometer_html_af2f25ccdc72808fc5e4baeeb60fe9410"><div class="ttname"><a href="class_potentiometer.html#af2f25ccdc72808fc5e4baeeb60fe9410">Potentiometer::Potentiometer</a></div><div class="ttdeci">Potentiometer(int pin, int id=99)</div><div class="ttdoc">Class constructor.</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- HTML footer for doxygen 1.8.18-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.9.1
</small></address>
</body>
</html>
